> ## Documentation Index
> Fetch the complete documentation index at: https://novu-c5de82d9-docs-homepage-redesign.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Generate a step preview

> Generate a step preview using the Novu REST API. Requires your environment secret key in the Authorization header.



## OpenAPI

````yaml POST /v2/workflows/{workflowId}/step/{stepId}/preview
openapi: 3.0.0
info:
  title: Novu API
  description: >-
    Novu REST API. Please see https://docs.novu.co/api-reference for more
    details.
  version: 3.15.0
  contact:
    name: Novu Support
    url: https://discord.gg/novu
    email: support@novu.co
  termsOfService: https://novu.co/terms
  license:
    name: MIT
    url: https://opensource.org/license/mit
servers:
  - url: https://api.novu.co
  - url: https://eu.api.novu.co
security:
  - secretKey: []
tags:
  - name: Events
    description: >-
      Events represent a change in state of a subscriber. They are used to
      trigger workflows, and enable you to send notifications to subscribers
      based on their actions.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Subscribers
    description: >-
      A subscriber in Novu represents someone who should receive a message. A
      subscriber's profile information contains important attributes about the
      subscriber that will be used in messages (name, email). The subscriber
      object can contain other key-value pairs that can be used to further
      personalize your messages.
    externalDocs:
      url: https://docs.novu.co/subscribers/subscribers
  - name: Topics
    description: >-
      Topics are a way to group subscribers together so that they can be
      notified of events at once. A topic is identified by a custom key. This
      can be helpful for things like sending out marketing emails or notifying
      users of new features. Topics can also be used to send notifications to
      the subscribers who have been grouped together based on their interests,
      location, activities and much more.
    externalDocs:
      url: https://docs.novu.co/subscribers/topics
  - name: Integrations
    description: >-
      With the help of the Integration Store, you can easily integrate your
      favorite delivery provider. During the runtime of the API, the
      Integrations Store is responsible for storing the configurations of all
      the providers.
    externalDocs:
      url: https://docs.novu.co/platform/integrations/overview
  - name: Workflows
    description: >-
      All notifications are sent via a workflow. Each workflow acts as a
      container for the logic and blueprint that are associated with a type of
      notification in your system.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Messages
    description: >-
      A message in Novu represents a notification delivered to a recipient on a
      particular channel. Messages contain information about the request that
      triggered its delivery, a view of the data sent to the recipient, and a
      timeline of its lifecycle events. Learn more about messages.
    externalDocs:
      url: https://docs.novu.co/workflows/messages
  - name: Environments
    description: >-
      Environments allow you to manage different stages of your application
      development lifecycle. Each environment has its own set of API keys and
      configurations, enabling you to separate development, staging, and
      production workflows.
    externalDocs:
      url: https://docs.novu.co/platform/environments
  - name: Layouts
    description: Layouts are reusable wrappers for your email notifications.
    externalDocs:
      url: https://docs.novu.co/platform/workflow/layouts
  - name: Translations
    description: Used to localize your notifications to different languages.
    externalDocs:
      url: https://docs.novu.co/platform/workflow/advanced-features/translations
  - name: Domains
    description: Used to manage your inbound email domains.
    externalDocs:
      url: https://docs.novu.co/platform/domains
externalDocs:
  description: Novu Documentation
  url: https://docs.novu.co
paths:
  /v2/workflows/{workflowId}/step/{stepId}/preview:
    post:
      tags:
        - Workflows
      summary: Generate a step preview
      description: >-
        Generates a preview for a specific workflow step by its unique
        identifier **stepId**
      operationId: WorkflowController_generatePreview
      parameters:
        - name: workflowId
          required: true
          in: path
          schema:
            type: string
        - name: stepId
          required: true
          in: path
          schema:
            type: string
        - name: idempotency-key
          in: header
          description: A header for idempotency purposes
          required: false
          schema:
            type: string
      requestBody:
        required: true
        description: Preview generation details
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/GeneratePreviewRequestDto'
      responses:
        '201':
          description: Created
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GeneratePreviewResponseDto'
        '400':
          description: Bad Request
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '401':
          description: Unauthorized
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '403':
          description: Forbidden
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '404':
          description: Not Found
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '405':
          description: Method Not Allowed
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '409':
          description: Conflict
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '413':
          description: Payload Too Large
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '414':
          description: URI Too Long
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '415':
          description: Unsupported Media Type
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '422':
          description: Unprocessable Entity
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationErrorDto'
        '429':
          description: 'The client has sent too many requests in a given amount of time. '
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
            Retry-After:
              $ref: '#/components/headers/Retry-After'
          content:
            application/json:
              schema:
                type: string
                example: API rate limit exceeded
        '500':
          description: Internal Server Error
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorDto'
        '503':
          description: >-
            The server is currently unable to handle the request due to a
            temporary overload or scheduled maintenance, which will likely be
            alleviated after some delay.
          headers:
            Content-Type:
              $ref: '#/components/headers/Content-Type'
            RateLimit-Limit:
              $ref: '#/components/headers/RateLimit-Limit'
            RateLimit-Remaining:
              $ref: '#/components/headers/RateLimit-Remaining'
            RateLimit-Reset:
              $ref: '#/components/headers/RateLimit-Reset'
            RateLimit-Policy:
              $ref: '#/components/headers/RateLimit-Policy'
            Idempotency-Key:
              $ref: '#/components/headers/Idempotency-Key'
            Idempotency-Replay:
              $ref: '#/components/headers/Idempotency-Replay'
            Retry-After:
              $ref: '#/components/headers/Retry-After'
          content:
            application/json:
              schema:
                type: string
                example: Please wait some time, then try again.
      security:
        - secretKey: []
      x-codeSamples:
        - lang: php
          label: PHP
          source: >-
            declare(strict_types=1);


            require 'vendor/autoload.php';


            use novu;

            use novu\Models\Components;


            $sdk = novu\Novu::builder()
                ->setSecurity(
                    'YOUR_SECRET_KEY_HERE'
                )
                ->build();

            $generatePreviewRequestDto = new
            Components\GeneratePreviewRequestDto(
                previewPayload: new Components\PreviewPayloadDto(
                    subscriber: new Components\SubscriberResponseDtoOptional(
                        channels: [
                            new Components\ChannelSettingsDto(
                                providerId: Components\ChatOrPushProviderEnum::NovuSlack,
                                credentials: new Components\ChannelCredentials(
                                    webhookUrl: 'https://example.com/webhook',
                                    channel: 'general',
                                    deviceTokens: [
                                        'token1',
                                        'token2',
                                        'token3',
                                    ],
                                    alertUid: '12345-abcde',
                                    title: 'Critical Alert',
                                    imageUrl: 'https://example.com/image.png',
                                    state: 'resolved',
                                    externalUrl: 'https://example.com/details',
                                ),
                                integrationId: '<id>',
                            ),
                        ],
                    ),
                    context: [
                        'key' => 'org-acme',
                    ],
                ),
            );


            $response = $sdk->workflows->steps->generatePreview(
                workflowId: '<id>',
                stepId: '<id>',
                generatePreviewRequestDto: $generatePreviewRequestDto

            );


            if ($response->generatePreviewResponseDto !== null) {
                // handle response
            }
        - lang: python
          label: Python
          source: |-
            import novu_py
            from novu_py import Novu


            with Novu(
                secret_key="YOUR_SECRET_KEY_HERE",
            ) as novu:

                res = novu.workflows.steps.generate_preview(workflow_id="<id>", step_id="<id>", generate_preview_request_dto={
                    "preview_payload": {
                        "subscriber": {
                            "channels": [
                                {
                                    "provider_id": novu_py.ChatOrPushProviderEnum.NOVU_SLACK,
                                    "credentials": {
                                        "webhook_url": "https://example.com/webhook",
                                        "channel": "general",
                                        "device_tokens": [
                                            "token1",
                                            "token2",
                                            "token3",
                                        ],
                                        "alert_uid": "12345-abcde",
                                        "title": "Critical Alert",
                                        "image_url": "https://example.com/image.png",
                                        "state": "resolved",
                                        "external_url": "https://example.com/details",
                                    },
                                    "integration_id": "<id>",
                                },
                            ],
                        },
                        "context": {
                            "key": "org-acme",
                        },
                    },
                })

                # Handle response
                print(res)
        - lang: go
          label: Go
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/novuhq/novu-go/v3\"\n\t\"github.com/novuhq/novu-go/v3/models/components\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := v3.New(\n        v3.WithSecurity(\"YOUR_SECRET_KEY_HERE\"),\n    )\n\n    res, err := s.Workflows.Steps.GeneratePreview(ctx, \"<id>\", \"<id>\", components.GeneratePreviewRequestDto{\n        PreviewPayload: &components.PreviewPayloadDto{\n            Subscriber: &components.SubscriberResponseDtoOptional{\n                Channels: []components.ChannelSettingsDto{\n                    components.ChannelSettingsDto{\n                        ProviderID: components.ChatOrPushProviderEnumNovuSlack,\n                        Credentials: components.ChannelCredentials{\n                            WebhookURL: v3.Pointer(\"https://example.com/webhook\"),\n                            Channel: v3.Pointer(\"general\"),\n                            DeviceTokens: []string{\n                                \"token1\",\n                                \"token2\",\n                                \"token3\",\n                            },\n                            AlertUID: v3.Pointer(\"12345-abcde\"),\n                            Title: v3.Pointer(\"Critical Alert\"),\n                            ImageURL: v3.Pointer(\"https://example.com/image.png\"),\n                            State: v3.Pointer(\"resolved\"),\n                            ExternalURL: v3.Pointer(\"https://example.com/details\"),\n                        },\n                        IntegrationID: \"<id>\",\n                    },\n                },\n            },\n            Context: map[string]components.PreviewPayloadDtoContext{\n                \"key\": components.CreatePreviewPayloadDtoContextStr(\n                    \"org-acme\",\n                ),\n            },\n        },\n    }, nil)\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.GeneratePreviewResponseDto != nil {\n        switch res.GeneratePreviewResponseDto.Result.Type {\n            case components.GeneratePreviewResponseDtoResultUnionTypeMapOfAny:\n                // res.GeneratePreviewResponseDto.Result.MapOfAny is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeResult2:\n                // res.GeneratePreviewResponseDto.Result.Result2 is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeThree:\n                // res.GeneratePreviewResponseDto.Result.Three is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeResult4:\n                // res.GeneratePreviewResponseDto.Result.Result4 is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeResult5:\n                // res.GeneratePreviewResponseDto.Result.Result5 is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeSix:\n                // res.GeneratePreviewResponseDto.Result.Six is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeSeven:\n                // res.GeneratePreviewResponseDto.Result.Seven is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeEight:\n                // res.GeneratePreviewResponseDto.Result.Eight is populated\n            case components.GeneratePreviewResponseDtoResultUnionTypeNine:\n                // res.GeneratePreviewResponseDto.Result.Nine is populated\n        }\n\n    }\n}"
        - lang: typescript
          label: TypeScript
          source: |-
            import { Novu } from "@novu/api";

            const novu = new Novu({
              secretKey: "YOUR_SECRET_KEY_HERE",
            });

            async function run() {
              const result = await novu.workflows.steps.generatePreview({
                workflowId: "<id>",
                stepId: "<id>",
                generatePreviewRequestDto: {
                  previewPayload: {
                    subscriber: {
                      channels: [
                        {
                          providerId: "novu-slack",
                          credentials: {
                            webhookUrl: "https://example.com/webhook",
                            channel: "general",
                            deviceTokens: [
                              "token1",
                              "token2",
                              "token3",
                            ],
                            alertUid: "12345-abcde",
                            title: "Critical Alert",
                            imageUrl: "https://example.com/image.png",
                            state: "resolved",
                            externalUrl: "https://example.com/details",
                          },
                          integrationId: "<id>",
                        },
                      ],
                    },
                    context: {
                      "key": "org-acme",
                    },
                  },
                },
              });

              console.log(result);
            }

            run();
        - lang: csharp
          label: Csharp (SDK)
          source: |-
            using Novu;
            using Novu.Models.Components;
            using System.Collections.Generic;

            var sdk = new NovuSDK(secretKey: "YOUR_SECRET_KEY_HERE");

            var res = await sdk.Workflows.Steps.GeneratePreviewAsync(
                workflowId: "<id>",
                stepId: "<id>",
                generatePreviewRequestDto: new GeneratePreviewRequestDto() {
                    PreviewPayload = new PreviewPayloadDto() {
                        Subscriber = new SubscriberResponseDtoOptional() {
                            Channels = new List<ChannelSettingsDto>() {
                                new ChannelSettingsDto() {
                                    ProviderId = ChatOrPushProviderEnum.NovuSlack,
                                    Credentials = new ChannelCredentials() {
                                        WebhookUrl = "https://example.com/webhook",
                                        Channel = "general",
                                        DeviceTokens = new List<string>() {
                                            "token1",
                                            "token2",
                                            "token3",
                                        },
                                        AlertUid = "12345-abcde",
                                        Title = "Critical Alert",
                                        ImageUrl = "https://example.com/image.png",
                                        State = "resolved",
                                        ExternalUrl = "https://example.com/details",
                                    },
                                    IntegrationId = "<id>",
                                },
                            },
                        },
                        Context = new Dictionary<string, PreviewPayloadDtoContext>() {
                            { "key", PreviewPayloadDtoContext.CreateStr(
                                "org-acme"
                            ) },
                        },
                    },
                }
            );

            // handle response
components:
  schemas:
    GeneratePreviewRequestDto:
      type: object
      properties:
        controlValues:
          type: object
          description: Optional control values
          additionalProperties: true
        previewPayload:
          description: Optional payload for preview generation
          allOf:
            - $ref: '#/components/schemas/PreviewPayloadDto'
    GeneratePreviewResponseDto:
      type: object
      properties:
        previewPayloadExample:
          description: Preview payload example
          allOf:
            - $ref: '#/components/schemas/PreviewPayloadDto'
        schema:
          type: object
          nullable: true
          description: >-
            The payload schema that was used to generate the preview payload
            example
          additionalProperties: true
        novuSignature:
          type: string
          description: Sample novu-signature header value for HTTP request steps
        result:
          description: Preview result
          oneOf:
            - type: object
              additionalProperties: true
            - properties:
                type:
                  enum:
                    - email
                preview:
                  $ref: '#/components/schemas/EmailRenderOutput'
                error:
                  $ref: '#/components/schemas/PreviewErrorDto'
            - properties:
                type:
                  enum:
                    - email
                preview:
                  $ref: '#/components/schemas/EmailRenderOutput'
                error:
                  $ref: '#/components/schemas/PreviewErrorDto'
            - properties:
                type:
                  enum:
                    - in_app
                preview:
                  $ref: '#/components/schemas/InAppRenderOutput'
                error:
                  $ref: '#/components/schemas/PreviewErrorDto'
            - properties:
                type:
                  enum:
                    - sms
                preview:
                  $ref: '#/components/schemas/SmsRenderOutput'
                error:
                  $ref: '#/components/schemas/PreviewErrorDto'
            - properties:
                type:
                  enum:
                    - push
                preview:
                  $ref: '#/components/schemas/PushRenderOutput'
                error:
                  $ref: '#/components/schemas/PreviewErrorDto'
            - properties:
                type:
                  enum:
                    - chat
                preview:
                  $ref: '#/components/schemas/ChatRenderOutput'
                error:
                  $ref: '#/components/schemas/PreviewErrorDto'
            - properties:
                type:
                  enum:
                    - delay
                preview:
                  $ref: '#/components/schemas/DigestRegularOutput'
            - properties:
                type:
                  enum:
                    - digest
                preview:
                  $ref: '#/components/schemas/DigestRegularOutput'
      required:
        - previewPayloadExample
        - result
    ErrorDto:
      type: object
      properties:
        statusCode:
          type: number
          description: HTTP status code of the error response.
          example: 404
        timestamp:
          type: string
          description: Timestamp of when the error occurred.
          example: '2024-12-12T13:00:00Z'
        path:
          type: string
          description: The path where the error occurred.
          example: /api/v1/resource
        message:
          description: Value that failed validation
          oneOf:
            - type: string
              nullable: true
            - type: number
            - type: boolean
            - type: object
              nullable: true
            - type: array
              items:
                anyOf:
                  - type: string
                    nullable: true
                  - type: number
                  - type: boolean
                  - type: object
                    additionalProperties: true
          example: 'xx xx xx '
        ctx:
          type: object
          description: Optional context object for additional error details.
          additionalProperties: true
          example:
            workflowId: some_wf_id
            stepId: some_wf_id
        errorId:
          type: string
          description: >-
            Optional unique identifier for the error, useful for tracking using
            Sentry and 
                  New Relic, only available for 500.
          example: abc123
      required:
        - statusCode
        - timestamp
        - path
    ValidationErrorDto:
      type: object
      properties:
        statusCode:
          type: number
          description: HTTP status code of the error response.
          example: 404
        timestamp:
          type: string
          description: Timestamp of when the error occurred.
          example: '2024-12-12T13:00:00Z'
        path:
          type: string
          description: The path where the error occurred.
          example: /api/v1/resource
        message:
          description: Value that failed validation
          oneOf:
            - type: string
              nullable: true
            - type: number
            - type: boolean
            - type: object
              nullable: true
            - type: array
              items:
                anyOf:
                  - type: string
                    nullable: true
                  - type: number
                  - type: boolean
                  - type: object
                    additionalProperties: true
          example: 'xx xx xx '
        ctx:
          type: object
          description: Optional context object for additional error details.
          additionalProperties: true
          example:
            workflowId: some_wf_id
            stepId: some_wf_id
        errorId:
          type: string
          description: >-
            Optional unique identifier for the error, useful for tracking using
            Sentry and 
                  New Relic, only available for 500.
          example: abc123
        errors:
          type: object
          description: A record of validation errors keyed by field name
          additionalProperties:
            $ref: '#/components/schemas/ConstraintValidation'
          example:
            fieldName1:
              messages:
                - Field is required
                - Must be a valid email address
              value: invalidEmail
            fieldName2:
              messages:
                - Must be at least 18 years old
              value: 17
            fieldName3:
              messages:
                - Must be a boolean value
              value: true
            fieldName4:
              messages:
                - Must be a valid object
              value:
                key: value
            fieldName5:
              messages:
                - Field is missing
              value: null
            fieldName6:
              messages:
                - Undefined value
      required:
        - statusCode
        - timestamp
        - path
        - errors
    PreviewPayloadDto:
      type: object
      properties:
        subscriber:
          description: Partial subscriber information
          allOf:
            - $ref: '#/components/schemas/SubscriberResponseDtoOptional'
        payload:
          type: object
          description: Payload data
          additionalProperties: true
        steps:
          type: object
          description: Steps data
          additionalProperties: true
        context:
          type: object
          additionalProperties:
            oneOf:
              - type: string
                description: Simple context id
                example: org-acme
              - type: object
                description: Rich context object with id and optional data
                properties:
                  id:
                    type: string
                    example: org-acme
                  data:
                    type: object
                    description: Optional additional context data
                    additionalProperties: true
                    example:
                      name: Acme Corp
                      region: us-east-1
                required:
                  - id
        env:
          type: object
          description: Environment variables data
          additionalProperties: true
    EmailRenderOutput:
      type: object
      properties:
        subject:
          type: string
          description: Subject of the email
        body:
          type: string
          description: Body of the email
      required:
        - subject
        - body
    PreviewErrorDto:
      type: object
      properties:
        title:
          type: string
          description: Short error title
        message:
          type: string
          description: Detailed error message
        hint:
          type: string
          description: Actionable hint for the user
      required:
        - title
        - message
        - hint
    InAppRenderOutput:
      type: object
      properties:
        subject:
          type: string
          description: Subject of the in-app notification
        body:
          type: string
          description: Body of the in-app notification
        avatar:
          type: string
          description: Avatar for the in-app notification
        primaryAction:
          description: Primary action details
          allOf:
            - $ref: '#/components/schemas/ActionDto'
        secondaryAction:
          description: Secondary action details
          allOf:
            - $ref: '#/components/schemas/ActionDto'
        data:
          type: object
          description: Additional data
          additionalProperties: true
        redirect:
          description: Redirect details
          allOf:
            - $ref: '#/components/schemas/RedirectDto'
      required:
        - body
    SmsRenderOutput:
      type: object
      properties:
        body:
          type: string
          description: Body of the SMS message
      required:
        - body
    PushRenderOutput:
      type: object
      properties:
        subject:
          type: string
          description: Subject of the push notification
        body:
          type: string
          description: Body of the push notification
      required:
        - subject
        - body
    ChatRenderOutput:
      type: object
      properties:
        body:
          type: string
          description: Body of the chat message
      required:
        - body
    DigestRegularOutput:
      type: object
      properties:
        amount:
          type: number
          description: Amount of time units
        unit:
          $ref: '#/components/schemas/TimeUnitEnum'
        digestKey:
          type: string
          description: Optional digest key
        lookBackWindow:
          type: object
          description: Look back window configuration
      required:
        - amount
        - unit
    ConstraintValidation:
      type: object
      properties:
        messages:
          type: array
          items:
            type: string
          description: List of validation error messages
          example:
            - Field is required
            - Invalid format
        value:
          description: Value that failed validation
          oneOf:
            - type: string
              nullable: true
            - type: number
            - type: boolean
            - type: object
            - type: array
              items:
                anyOf:
                  - type: string
                    nullable: true
                  - type: number
                  - type: boolean
                  - type: object
                    additionalProperties: true
          example: 'xx xx xx '
      required:
        - messages
    SubscriberResponseDtoOptional:
      type: object
      properties:
        _id:
          type: string
          description: >-
            The internal ID generated by Novu for your subscriber. This ID does
            not match the `subscriberId` used in your queries. Refer to
            `subscriberId` for that identifier.
        firstName:
          type: string
          description: The first name of the subscriber.
          nullable: true
        lastName:
          type: string
          description: The last name of the subscriber.
          nullable: true
        email:
          type: string
          description: The email address of the subscriber.
          nullable: true
        phone:
          type: string
          description: The phone number of the subscriber.
          nullable: true
        avatar:
          type: string
          description: The URL of the subscriber's avatar image.
          nullable: true
        locale:
          type: string
          description: >-
            The locale setting of the subscriber, indicating their preferred
            language or region.
          nullable: true
        channels:
          description: An array of channel settings associated with the subscriber.
          type: array
          items:
            $ref: '#/components/schemas/ChannelSettingsDto'
        topics:
          description: An array of topics that the subscriber is subscribed to.
          deprecated: true
          type: array
          items:
            type: string
        isOnline:
          type: boolean
          description: Indicates whether the subscriber is currently online.
          nullable: true
        lastOnlineAt:
          type: string
          description: >-
            The timestamp indicating when the subscriber was last online, in ISO
            8601 format.
          nullable: true
        __v:
          type: number
          description: The version of the subscriber document.
        data:
          type: object
          description: Additional custom data for the subscriber
          additionalProperties: true
          nullable: true
        timezone:
          type: string
          description: Timezone of the subscriber
          nullable: true
    ActionDto:
      type: object
      properties:
        label:
          type: string
          description: Label for the action button.
        redirect:
          description: Redirect configuration for the action.
          allOf:
            - $ref: '#/components/schemas/RedirectDto'
    RedirectDto:
      type: object
      properties:
        url:
          type: string
          description: URL to redirect to
        target:
          type: string
          description: Target attribute for the redirect link
          enum:
            - _self
            - _blank
            - _parent
            - _top
            - _unfencedTop
      required:
        - url
    TimeUnitEnum:
      type: string
      description: Time unit
      enum:
        - seconds
        - minutes
        - hours
        - days
        - weeks
        - months
    ChannelSettingsDto:
      type: object
      properties:
        providerId:
          $ref: '#/components/schemas/ChatOrPushProviderEnum'
        integrationIdentifier:
          type: string
          description: The integration identifier
        credentials:
          description: Credentials payload for the specified provider
          allOf:
            - $ref: '#/components/schemas/ChannelCredentials'
        _integrationId:
          type: string
          description: >-
            The unique identifier of the integration associated with this
            channel.
      required:
        - providerId
        - credentials
        - _integrationId
    ChatOrPushProviderEnum:
      type: string
      description: The provider identifier for the credentials
      enum:
        - slack
        - discord
        - msteams
        - mattermost
        - ryver
        - zulip
        - grafana-on-call
        - getstream
        - rocket-chat
        - whatsapp-business
        - chat-webhook
        - novu-slack
        - telegram
        - fcm
        - apns
        - expo
        - one-signal
        - pushpad
        - push-webhook
        - pusher-beams
        - appio
    ChannelCredentials:
      type: object
      properties:
        webhookUrl:
          type: string
          description: >-
            Webhook URL used by chat app integrations. The webhook should be
            obtained from the chat app provider.
          example: https://example.com/webhook
        channel:
          type: string
          description: Channel specification for Mattermost chat notifications.
          example: general
        deviceTokens:
          description: >-
            Contains an array of the subscriber device tokens for a given
            provider. Used on Push integrations.
          example:
            - token1
            - token2
            - token3
          type: array
          items:
            type: string
        alertUid:
          type: string
          description: Alert UID for Grafana on-call webhook payload.
          example: 12345-abcde
        title:
          type: string
          description: Title to be used with Grafana on-call webhook.
          example: Critical Alert
        imageUrl:
          type: string
          description: Image URL property for Grafana on-call webhook.
          example: https://example.com/image.png
        state:
          type: string
          description: State property for Grafana on-call webhook.
          example: resolved
        externalUrl:
          type: string
          description: Link to upstream details property for Grafana on-call webhook.
          example: https://example.com/details
  headers:
    Content-Type:
      required: true
      description: The MIME type of the response body.
      schema:
        type: string
      example: application/json
    RateLimit-Limit:
      required: false
      description: >-
        The number of requests that the client is permitted to make per second.
        The actual maximum may differ when burst is enabled.
      schema:
        type: string
      example: '100'
    RateLimit-Remaining:
      required: false
      description: The number of requests remaining until the next window.
      schema:
        type: string
      example: '93'
    RateLimit-Reset:
      required: false
      description: >-
        The remaining seconds until a request of the same cost will be
        refreshed.
      schema:
        type: string
      example: '8'
    RateLimit-Policy:
      required: false
      description: The rate limit policy that was used to evaluate the request.
      schema:
        type: string
      example: >-
        100;w=1;burst=110;comment="token
        bucket";category="trigger";cost="single"
    Idempotency-Key:
      required: false
      description: The idempotency key used to evaluate the request.
      schema:
        type: string
      example: '8'
    Idempotency-Replay:
      required: false
      description: Whether the request was a replay of a previous request.
      schema:
        type: string
      example: 'true'
    Retry-After:
      required: false
      description: >-
        The number of seconds after which the client may retry the request that
        was previously rejected.
      schema:
        type: string
      example: '8'
  securitySchemes:
    secretKey:
      type: apiKey
      name: Authorization
      in: header
      description: >-
        API key authentication. Allowed headers-- "Authorization: ApiKey
        <novu_secret_key>".
      x-speakeasy-example: YOUR_SECRET_KEY_HERE

````